/*****************************************************************************/
/*       (C) 1993,1994 R. NADE - M. GRANDCHAMP - All Rights Reserved         */
/*****************************************************************************/
/*    This source-code is NOT public domain nor Freeware, this is part of    */
/*              'The C Programming Package' which is Shareware.              */
/*   If you use this code, please register and get a free Full-VGA version   */
/*****************************************************************************/
                            /*----------------------*
                             *      CPPFIC1A.C      *
                             *     File Manager     *
                             *    First Part 1/2    *
                             *----------------------*/

 /* Included Files */
 # include <stdio.h>
 # include <io.h>
 # include <dos.h>
 # include <fcntl.h>
 # include <bios.h>
 # include <stdlib.h>
 # include <conio.h>
 # include <dir.h>
 # include <string.h>
 # include <alloc.h>
 # include <mem.h>

 /* Global Variables */
 extern int bm,i,j,k,l,m,n,t,x,x1,x2,xm,y,y1,y2,ym,z,menu0,menu1,return1;
 extern int colour1,colour2,colour3,colour4,colour5,nbdisk,return2,return3,recording;
 extern int lline,linemax,choice,modif,pfdiv;
 extern unsigned int ref,nbref,nbrep;
 extern long depdiv;
 extern unsigned long nbbytes;
 extern unsigned char c0,c1,trashcan[],path[],nc1[],trashret[],filedir[];
 extern struct ffblk ffblk;
/* extern struct directory directory; */
 extern char *beginning,*fin,*memory;
 extern struct directory{
                       unsigned char name[9];
                       unsigned char ext[4];
                       unsigned char size[9];
                       unsigned char attribut[2];
                       unsigned char date[9];
                       unsigned char time[6];
                     } directory;

 /*--------------------*
  * DIRECTORY CHANGING *
  *--------------------*/
  void directory_changing()
    {
      if(directory.name[0]==0x2e){
        /* Upward directory */
        if(directory.name[1]==0x2e){
          /* Two dots = back to the parent directory */
	  system("cd..");
	}
	else{
          /* One dot = back to the root of the drive */
	  system("cd\\");
	}
      }
      else{
        /* Another char, downward directory */
        chdir(filedir);                 return;
      }
    }
 /*----------------*
  * PUT SEPARATORS *
  *----------------*/
  void put_separators()
    {
      /* If required put separators */
      i=strlen(trashcan);
      if((i>3)&&(i<7)){
        trashcan[i+1]=0x00;
        for(j=0; j<3; j++)             trashcan[i-j]=trashcan[i-j-1];
        trashcan[i-3]=0x2e;            return;
      }
      if((i>6)&&(i<10)){
        trashcan[i+2]=0x00;
        for(j=0; j<3; j++)             trashcan[i-j+1]=trashcan[i-j-1];
        for(j=0; j<3; j++)             trashcan[i-j]=trashcan[i-j-1];
        trashcan[i-2]=0x2e;            trashcan[i-6]=0x2e;
      }
    }
 /*------------------------------------*
  * CALCULATE AND DISPLAY SUM OF FILES *
  *------------------------------------*/
  void calculate_and_display_sum_of_files()
    {
      /* First, calculate files sizes */
      nbbytes=0L;                     memory=beginning+13;
      i=0;                            nbrep=0;
      while(i++<nbref){
        memcpy(trashcan,memory,9);    memory+=9;
        nbbytes+=atol(trashcan);
        memcpy(trashcan,memory,2);    memory+=30;
        if(trashcan[0]==0x10)         nbrep++;
      }
      /* Then display the sizes */
      textattr(colour4);
      gotoxy(2,19);   cputs(" Total=     Direct. ");
      gotoxy(2,20);   cputs("            Files   ");
      gotoxy(2,21);   cputs("            Bytes  ");
      itoa(nbrep,trashcan,10);         put_separators();
      right_justify_the_text(trashcan,3);
      gotoxy(10,19);                   cputs(trashret);
      itoa((nbref-nbrep),trashcan,10); put_separators();
      right_justify_the_text(trashcan,5);
      gotoxy(8,20);                    cputs(trashret);
      ltoa(nbbytes,trashcan,10);
      put_separators();                right_justify_the_text(trashcan,10);
      gotoxy(3,21);                    cputs(trashret);
    }
 /*----------------------*
  * DISPLAY DRIVE CHOICE *
  *----------------------*/
  void display_drive_choice()
    {
      textattr(colour4);               hide_the_mouse();
      /* First display the drives */
      /* Then overline key letters in red */
      gotoxy(69,5);                    cputs("ͻ");
      gotoxy(69,6);                    cputs(" drive A: ");
      gotoxy(69,7);                    cputs(" drive B: ");
      gotoxy(69,8);                    cputs("          ");
      gotoxy(69,9);                    cputs("          ");
      gotoxy(69,10);                   cputs("͹");
      if(nbdisk>2){
        /* At least 3 drives */
        gotoxy(70,8);                  cputs(" drive C: ");
	textattr(116);
    gotoxy(77,8);                      cputs("C");
	if(nbdisk==4){
          /* 4 drives */
          textattr(colour4);
          gotoxy(70,9);                cputs(" drive D: ");
	  textattr(116);
      gotoxy(77,9);                    cputs("D");
	}
      }
      textattr(116);
      gotoxy(77,6);                    cputs("A");
      gotoxy(77,7);                    cputs("B");
      /* Which one is the active one ? */
      i=getdisk();                     textattr(colour5);
      if(i==0){
        /* floppy A: */
        gotoxy(70,6);                  cputs(" drive A: ");
      }
      if(i==1){
        /* floppy B: */
        gotoxy(70,7);                  cputs(" drive B: ");
      }
      if(i==2){
        /* floppy C: */
        gotoxy(70,8);                  cputs(" drive C: ");
      }
      if(i==3){
        /* floppy D: */
        gotoxy(70,9);                  cputs(" drive D: ");
      }
      /* Display the new selected access path */
      textattr(colour4);               gotoxy(2,23);
      cputs("                                                               ");
      gotoxy(2,23);                    cputs(path);
      show_the_mouse();
    }
 /*---------------------------*
  * DISPLAY MENU FILE MANAGER *
  *---------------------------*/
  void display_menu_file_manager(order)
    int order;
    {
      /* Display lines in normal attributes */
      textattr(colour4);                 hide_the_mouse();
      gotoxy(70,11);                   cputs("Beg. dir. ");
      gotoxy(70,12);                   cputs("Prev. page");
      gotoxy(70,13);                   cputs("  Upward  ");
      gotoxy(70,14);                   cputs(" Downward ");
      gotoxy(70,15);                   cputs("Next page ");
      gotoxy(70,16);                   cputs(" End dir. ");
      gotoxy(70,18);                   cputs("Sel. file ");
      gotoxy(70,19);                   cputs("sOrt/ name");
      gotoxy(70,20);                   cputs("deL.  file");
      gotoxy(70,21);                   cputs("  Record  ");
      gotoxy(70,23);                   cputs("   Quit   ");
      /* Overline the key letter in red on lightgrey */
      textattr(116);
      gotoxy(70,11);                   cputs("B");
      gotoxy(70,12);                   cputs("P");
      gotoxy(72,13);                   cputs("U");
      gotoxy(71,14);                   cputs("D");
      gotoxy(70,15);                   cputs("N");
      gotoxy(71,16);                   cputs("E");
      gotoxy(70,18);                   cputs("S");
      gotoxy(71,19);                   cputs("O");
      gotoxy(72,20);                   cputs("L");
      gotoxy(72,21);                   cputs("R");
      gotoxy(73,23);                   cputs("Q");
      /* Display in inverse video the selected line */
      textattr(colour5);
      if(order==1){
        gotoxy(70,11);                 cputs("Beg. dir. ");
      }
      if(order==2){
        gotoxy(70,12);                 cputs("Prev. page");
      }
      if(order==3){
        gotoxy(70,13);                 cputs("  Upward  ");
      }
      if(order==4){
        gotoxy(70,14);                 cputs(" Downward ");
      }
      if(order==5){
        gotoxy(70,15);                 cputs("Next page ");
      }
      if(order==6){
        gotoxy(70,16);                 cputs(" End dir. ");
      }
      if(order==7){
        gotoxy(70,18);                 cputs("Sel. file ");
      }
      if(order==8){
        gotoxy(70,19);                 cputs("sOrt/ name");
      }
      if(order==9){
        gotoxy(70,20);                 cputs("deL. file ");
      }
      if(order==10){
        gotoxy(70,21);                 cputs("  Record  ");
      }
      if(order==11){
        gotoxy(70,23);                 cputs("   Quit   ");
      }
      show_the_mouse();
    }
 /*-----------------------------*
  * DISPLAY DIRECTORIES LISTING *
  *-----------------------------*/
  void display_directories_listing()
    {
      hide_the_mouse();               textattr(colour4);
      /* Draw the border of the files listing */
      gotoxy(22,3);    cputs("ͻ");
      for(i=4; i<22; i++){
	gotoxy(22,i);  cputs("                                            ");
      }
      gotoxy(1,18);   cputs("͹");
      gotoxy(1,19);   cputs(" Total=     Direct. ");
      gotoxy(1,20);   cputs("            Files   ");
      gotoxy(1,21);   cputs("            Bytes   ");
      gotoxy(1,22);   cputs("͹");
      gotoxy(1,23);   cputs("                                                                 ");
      gotoxy(1,24);   cputs("  Access  path  to  files ͼ");
      /* Draw the menu */
      gotoxy(69,11);                   cputs("Beg. dir. ");
      gotoxy(69,12);                   cputs("Prev. page");
      gotoxy(69,13);                   cputs("  Upward  ");
      gotoxy(69,14);                   cputs(" Downward ");
      gotoxy(69,15);                   cputs("Next page ");
      gotoxy(69,16);                   cputs(" End dir. ");
      gotoxy(69,17);                   cputs("Ķ");
      gotoxy(69,18);                   cputs("Sel.  file");
      gotoxy(69,19);                   cputs("sOrt/ name");
      gotoxy(69,20);                   cputs("deL. file ");
      gotoxy(69,21);                   cputs("  Record  ");
      gotoxy(69,22);                   cputs("Ķ");
      gotoxy(69,23);                   cputs("   Quit   ");
      gotoxy(69,24);                   cputs("ͼ");
      show_the_mouse();
    }
 /*--------------------*
  * MOUSE FILE MANAGER *
  *--------------------*/
  int mouse_file_manager()
    {
      /* Check the selected line                  */
      /* If we changed of drive, we return 1      */
      /* If we scrolled the listing, we return 2  */
      /* If we are working on a file, we return 3 */
      /* In the menu choice, we update 'choice'   */
      if((xm>68)&&(xm<80)){
	if(ym==6){
	  system("a:");                modif=1;
	  return(1);
	}
	if(ym==7){
	  system("b:");                modif=1;
	  return(1);
	}
	if((ym==8)&&(nbdisk>2)){
	  system("c:");                modif=1;
	  return(1);
	}
	if((ym==9)&&(nbdisk>3)){
	  system("d:");                modif=1;
	  return(1);
	}
	if(ym==11){
          choice=1;                     return(2);
	}
	if(ym==12){
          choice=2;                     return(2);
	}
	if(ym==13){
          choice=3;                     return(2);
	}
	if(ym==14){
          choice=4;                     return(2);
	}
	if(ym==15){
          choice=5;                     return(2);
	}
	if(ym==16){
          choice=6;                     return(2);
	}
	if(ym==18){
          choice=7;                     return(3);
	}
	if(ym==19){
          choice=8;                     return(3);
	}
	if(ym==20){
          choice=9;                     return(3);
	}
	if(ym==21){
          choice=10;                    return(3);
	}
	if(ym==23){
          choice=11;                    return(-1);
	}
      }
      return(0);
    }
 /*---------------*
  * DRIVE MANAGER *
  *---------------*/
  int drive_manager()
    {
      return3=wait_for_a_key();
      /* If we pressed <Esc> <Q> <q> then Back to the menu */
      if((return3==-1)||(return3==26))   return(-1);
      if(return3==10){
	system("a:");                  modif=1;
	return(1);
      }
      if(return3==11){
	system("b:");                  modif=1;
	return(1);
      }
      if(return3==12){
	if(nbdisk>2){
	  system("c:");                modif=1;
	  return(1);
	}
      }
      if(return3==13){
	if(nbdisk>3){
	  system("d:");                modif=1;
	  return(1);
	}
     }
     if((return3==11)||(return3==71)){
       choice=1;                        return(2);
     }
     if((return3==25)||(return3==73)){
       choice=2;                        return(2);
     }
     if((return3==30)||(return3==72)){
       choice=3;                        return(2);
     }
     if((return3==13)||(return3==80)){
       choice=4;                        return(2);
     }
     if((return3==23)||(return3==81)){
       choice=5;                        return(2);
     }
     if((return3==14)||(return3==79)){
       choice=6;                        return(2);
     }
     if((return3==28)||(return3==40)){
       /* L or <Enter> */
       choice=7;                        return(3);
     }
     if(return3==24){
       choice=8;                        return(3);
     }
     if((return3==21)||(return3==83)){
       choice=9;                        return(3);
     }
     if(return3==27){
       choice=10;                       return(3);
     }
     if((return3==26)||(return3==-1)){
       choice=11;                       return(-1);
     }
     if(return3==59){
       /* <F1> = Help */
       return(59);
     }
     if(return3==100){
       /* We used the mouse */
       return3=mouse_file_manager();
       return(return3);
     }
     /* If we choosed something else or if we clicked */
     /* outside of the defined zone, nothing happens */
     return(0);
    }
 /*------------------*
  * DIRECTORY CHANGE *
  *------------------*/
  void directory_change()
    {
      /* We store directory files in RAM */
      /* First we allocate memory */
      /* i.e. 500 files a directory and 36 bytes a file */
      memory=farcalloc(500L,36L);
      if(memory==NULL){
        warning(" Memory Allocation"," problem"," for this"," directory","");
	return;
      }
      beginning=memory;
      /* We put the cursor at the default value : first line, */
      /* first choice and directory reading */
      lline=4;                         linemax=4;
      choice=1;
      x1=70;           x2=78;          y1=6;          y2=23;
      limit_the_mouse();              put_the_mouse(77,23);
      display_directories_listing();
      get_directory_files();
      /* Update the screen */
      display_drive_choice();     display_menu_file_manager(choice);
      while(1){
        display_current_line();
        /* Waiting for a new choice */
        return2=drive_manager();
	if(modif>0){
          /* Did we change of drive or directory ? */
          get_directory_files();
          display_drive_choice();
	}
        /* Update menu screen */
        display_menu_file_manager(choice);
        /* If we want to quit */
        if(return2==-1)                break;
        if(return2==2)                 scrolling_in_the_directory();
        if(return2==3)                 action_on_files_listing();
        if(return2==59){
          display_help("FILES",9,6,1);   restore_help_screen();
	}
      }
      /* Clean up the screen before returning to the menu */
      textattr(colour1);                 hide_the_mouse();
      window(22,3,68,24);              clrscr();
      window(68,5,80,24);              clrscr();
      window(1,17,22,24);              clrscr();
      window(1,1,80,25);               show_the_mouse();
      /* All the screen is available for the mouse */
      x1=1;            x2=80;          y1=1;        y2=25;
      limit_the_mouse();              recording=0;
      /* Free allocated memory */
      farfree(memory);
    }
/* End of the Module *//*----------------------*/

